clang 10.0.0git

Macros | Functions
FuchsiaHandleChecker.cpp File Reference
`#include "clang/AST/Attr.h"`
`#include "clang/AST/Decl.h"`
`#include "clang/AST/Type.h"`
`#include "clang/StaticAnalyzer/Checkers/BuiltinCheckerRegistration.h"`
`#include "clang/StaticAnalyzer/Core/BugReporter/BugType.h"`
`#include "clang/StaticAnalyzer/Core/Checker.h"`
`#include "clang/StaticAnalyzer/Core/CheckerManager.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/CallEvent.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/CheckerContext.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/ConstraintManager.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/ExplodedGraph.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/ProgramState.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/SymExpr.h"`
Include dependency graph for FuchsiaHandleChecker.cpp:

Go to the source code of this file.

## Macros
#define | CASE(ID)

## Functions
static const ExplodedNode * | getAcquireSite (const ExplodedNode *N, SymbolRef Sym, CheckerContext &Ctx)
static SymbolRef | getFuchsiaHandleSymbol (QualType QT, SVal Arg, ProgramStateRef State)
| Returns the symbols extracted from the argument or null if it cannot be found. More...

## Macro Definition Documentation

## ◆ CASE

#define CASE | ( |  | ID | ) |

Value:
case ID: \
OS << #ID; \
break;
clang::Builtin::ID
ID
Definition: Builtins.h:46

## Function Documentation

## ◆ getAcquireSite()

static const ExplodedNode* getAcquireSite | ( | const ExplodedNode * | N,
|  | SymbolRef | Sym,
|  | CheckerContext & | Ctx
| ) |  |
| static

Definition at line 202 of file FuchsiaHandleChecker.cpp.

Referenced by getFuchsiaHandleSymbol().

## ◆ getFuchsiaHandleSymbol()

static SymbolRef getFuchsiaHandleSymbol | ( | QualType | QT,
|  | SVal | Arg,
|  | ProgramStateRef | State
| ) |  |
| static

Returns the symbols extracted from the argument or null if it cannot be found.

Definition at line 226 of file FuchsiaHandleChecker.cpp.

References clang::ento::PathDiagnosticLocation::createBegin(), clang::ento::PathDiagnosticLocation::dump(), getAcquireSite(), clang::Type::getAs(), clang::FunctionDecl::getNumParams(), clang::FunctionDecl::getParamDecl(), clang::Type::getPointeeType(), clang::FunctionDecl::getReturnType(), clang::ValueDecl::getType(), clang::Type::isAnyPointerType(), clang::Type::isIntegerType(), clang::Type::isReferenceType(), clang::ento::PSK_DirectEscapeOnCall, clang::ento::PSK_EscapeOutParameters, clang::ento::PSK_IndirectEscapeOnCall, State, and Text.